const reminderFoxBundle = document.getElementById("reminderFox-bundle");  
var reminderFox_snoozed = false;

function loadAlarm() {
		var recentReminder = window.arguments[0].alarmreminder;		
		var snoozeTime = window.arguments[0].snoozeTime;				
		var listName = window.arguments[0].todoListName;

		var timeString = reminderFox_getTimeString(recentReminder);
		if ( timeString == null ) {
			timeString =  reminderFox_getBundle().getString("rf.add.time.allday");
		}
		
		var isTodo = false;
		var isReminder = window.arguments[0].isReminderType;
    	if ( isReminder != "true" ) {
			isTodo = true;
		}	 	
	
		recentReminder  = reminderFox_processReminderDescription(recentReminder, new Date().getFullYear(), isTodo);	


//gW  displayMail -----------
		if (recentReminder.messageID != null){
			var displayMailButton = document.getElementById("displayMail");
			displayMailButton.setAttribute('style', 'visibility: visible');
			displayMailButton.setAttribute('disabled', 'false');
		}

		
		var reminderString =  recentReminder.summary;
		
		var dateVariableString;
		try {
			dateVariableString = reminderFox_getUnicodePref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LIST_DATE_LABEL);
		} catch(e) {
		}			
		var dateString =reminderFox_getDateVariable( null, recentReminder.date, dateVariableString );		
		
		
		if ( snoozeTime != null && snoozeTime != "" && reminderFox_isInteger( snoozeTime ) ) {
			var snoozeTimeList = document.getElementById("reminderFox-snoozeTime");	
			
			var snoozeTimeInt = parseInt( snoozeTime );			
			var timeUnitsList = document.getElementById('reminderFox-alertTimeUnits');			
			if (  reminderFox_mod( snoozeTimeInt , (60 * 24) ) == 0 ) { 
				// days
				snoozeTimeList.label =( snoozeTimeInt / (60*24) );
				timeUnitsList.selectedIndex = 2;			
			}
			else if (  reminderFox_mod( snoozeTimeInt , 60 ) == 0 ) { 
				// hours
				snoozeTimeList.label = (snoozeTimeInt / 60);					
				timeUnitsList.selectedIndex = 1;
			}
			else {
				// minutes
				snoozeTimeList.label = snoozeTime;
				timeUnitsList.selectedIndex = 0;
			}									
		}
		
		if ( listName != null && listName.length > 0 && listName != "null" ) {
			document.title = 	document.title + " [" + listName  + "]";
		}
		
		// if this is a past reminder, indicate that in the title
		if (  window.arguments[0].alarmMissed == "true" ) {
			document.title = 	document.title + " (" + reminderFox_getBundle().getString( "rf.alarm.missedalarm.title" )  + ")";
		}
		
		document.getElementById("reminderDateText").setAttribute("value", dateString);
		document.getElementById("reminderTimeText").setAttribute("value", timeString);
		document.getElementById("reminderDescriptionText").setAttribute("value", reminderString);				
		if ( recentReminder.priority == REMINDER_PRIORITY_IMPORTANT) { 
			document.getElementById("reminderDescriptionText").setAttribute("style", "color: red;");
		}
		
		if ( recentReminder.notes != null ) { 
			document.getElementById("notesText").setAttribute("value", recentReminder.notes);		
			document.getElementById("notesText").removeAttribute( "hidden");
		}
		
		playAlarmSound();

}

function showMailInAlarm() {
	var displayMailButton = document.getElementById("displayMail");
	displayMailButton.setAttribute( "checked", false 	);
	
	var recentReminder = window.arguments[0].alarmreminder;
	displayMailbyMsgID(recentReminder);
}

function playAlarmSound() {
	// play a sound for notification (if the user elects to)
	try {
		var playSound = true;
		try {
			playSound = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." +  REMINDER_FOX_ALARM_SOUND);
		}
		catch ( e) {
		}
		if ( playSound ) {
			reminderFox_playSound();
	  	} // end if		
	}
	catch ( e ) {
	}
}

function reminderFox_editReminderFromAlarm() {
	var reminderID = window.arguments[0].currentAlarmId;
	if ( reminderID != null ) {
		reminderFox_openAddRemindersDialog2(reminderID);
	}
}

function reminderFox_openAddRemindersDialog2(reminderID) {
   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");
 	var isReminder = window.arguments[0].isReminderType;
 
 	
   if (topWindow) {
    	 topWindow.focus();
    	if ( isReminder == "true" ) {	 
			topWindow.	selectReminderById(reminderID	);
			topWindow.editReminder();
    	}
    	else { 
			var i;
			var reminderFoxTodosArrayArg =  reminderFox_getReminderTodos();
			for ( var n in reminderFoxTodosArrayArg ) {
				var reminderTodos = reminderFoxTodosArrayArg[n];
				for (  i = 0; i < reminderTodos.length; i++ ) {		
					if ( reminderTodos[i].id == reminderID ) {
						topWindow.	selectTodoById(n, reminderID	);
						topWindow.editTodo();
						break;
						
					}
				}
			}
		}    		
   }
   else {
   		var newOptions;
   	    if ( isReminder == "true" ) {	  
   			newOptions = { callback: window.arguments[0].synccallback,  clearMailLabelCallback: window.arguments[0].clearLabelCallback, editID: reminderID, isAReminder: isReminder, todoList: null };   			
			var dlg = window.openDialog("chrome://reminderfox/content/addreminder-dialog.xul",
							"addreminder-dialog", "chrome,centerscreen,resizable", "reminders", newOptions);   			

   	    }
   	    else {
			var reminderFoxTodosArrayArg =  reminderFox_getReminderTodos();
			for ( var n in reminderFoxTodosArrayArg ) {
				var reminderTodos = reminderFoxTodosArrayArg[n];
				for (  i = 0; i < reminderTodos.length; i++ ) {		
					if ( reminderTodos[i].id == reminderID ) {
				  	    	newOptions = { callback: window.arguments[0].synccallback, clearMailLabelCallback: window.arguments[0].clearLabelCallback, editID: reminderID, isAReminder: isReminder, todoList: n };
							var dlg = window.openDialog("chrome://reminderfox/content/addreminder-dialog.xul",
								"addreminder-dialog", "chrome,centerscreen,resizable", "reminders", newOptions);
						
					}
				}
			}   	    	
 
   	    }
	}
}


function reminderFox_alarmDone() {
	var actionList = document.getElementById("reminderFox-alarm-action");
	var actionIndex =	actionList.selectedIndex;		
	reminderFox_performAlarmAction( actionIndex );
}

function reminderFox_alarmClosed() {
	reminderFox_performAlarmAction( 0 );  // default action - acknowledge
}


function reminderFox_performAlarmAction(actionIndex) {
	var listName = window.arguments[0].todoListName;		
	if ( reminderFox_snoozed ) {  // if the alarm is snoozed, we'll do nothing
		return ;
	}
	if ( actionIndex == 3  ) { // open
		reminderFox_editReminderFromAlarm();
		return;
	}		

	var myAlarmId = window.arguments[0].currentAlarmId;
	var isReminder = window.arguments[0].isReminderType;
	var reminder;
	
	// need to clear my reminders/todos from memory (as they may have changed in edit window)
	// and refresh them	
	reminderFox_clearRemindersAndTodos();
	if ( isReminder == "true"  ) {
		reminder =	reminderFox_getRemindersById( myAlarmId);
	}
	else {
		reminder =	reminderFox_getSpecificTodoById( myAlarmId);
	}

	
	// mark reminder's last-acknowleged  (unless snooze was pressed)
	if ( reminder != null  ) {
		var removed = false;
		var completed = false;
		reminder.alarmLastAcknowledge = new Date().getTime();
		reminderFox_lastModifiedTime = reminderFox_prefs.getCharPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_LAST_MODIFIED) + "";
		
		if ( actionIndex == 1 )  { // mark as complete
			reminder.completedDate = new Date();
			completed = true;
		}
		else if ( actionIndex == 2 ) {  // delete
			// remove from model list
			if ( isReminder == "true"  ) {
				var reminders = reminderFox_getReminderEvents();		
				for( var i = 0; i < reminders.length; i++) {
					if ( reminders[i].id == reminder.id ) {
						reminderFox_removeElement(reminders, i);
						removed = true;
						break;					
					}
				}
			}
			else {			
				var reminderFoxTodosArrayArg =  reminderFox_getReminderTodos();
				for ( var n in reminderFoxTodosArrayArg ) {
					var reminderTodos = reminderFoxTodosArrayArg[n];
					for (  i = 0; i < reminderTodos.length; i++ ) {		
						if ( reminderTodos[i].id == reminder.id ) {
							reminderFox_removeElement(reminderTodos, i);
							removed = true;
							break;							
						}
					}
				}		
			}
		}
		
		if ( actionIndex == 1 || actionIndex == 2 ) { // we want to write out the file and mark it changed - and sync w/ network
			reminderFox_writeOutRemindersAndTodos(false);		 
			
			// this callback syncs the written changes to remote and does it in the background on the calling 
			// window (otherwise we have to keep this window open until the network function callback returns)
			var syncCallback = window.arguments[0].synccallback;
			if ( syncCallback != null ) {				
				var networkSync = REMINDER_FOX_NETWORK_SYNCHRONIZE_DEFAULT;		
				try {
					networkSync = reminderFox_prefs.getBoolPref(REMINDER_FOX_PREF + "." + REMINDER_FOX_NETWORK_SYNCHRONIZE);
				} catch(e) {
				}	
				if ( networkSync ) {				
					syncCallback();			
				}
			}	
		}
		else {
			// if we just acknowledged the reminder, don't do anything.  
			reminderFox_writeOutRemindersAndTodos(true);		 
		}
		
		var windowEnumerator =  reminderFox_getWindowEnumerator();
		if (windowEnumerator.hasMoreElements()) {			
			var oldestWindow = windowEnumerator.getNext();
			for ( var i = 0; i < oldestWindow.reminderFox_alarmList.length; i++ ) {
				var currentAlarmId =  oldestWindow.reminderFox_alarmList[i].alarmId;
				if ( currentAlarmId == myAlarmId ) { 
					reminderFox_removeElement( oldestWindow.reminderFox_alarmList, i);
				}
			}
		}
		
		
		
		// if the edit window is open and we Acknowledge this alarm, we need to set the lastAck  for this reminder instnace 
		// in the editWindow as well, or it will still have the old value and overwrite the correct one when the edit 
		// window is closed...
	   var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	   var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	   var topWindow = windowManagerInterface.getMostRecentWindow("window:reminderFoxEdit");	 
	   if (topWindow) {
	   		var editWindowReminder =	 null;
	   		if ( isReminder == "true"  ) {  
	   			editWindowReminder = topWindow.reminderFox_getRemindersById( myAlarmId );
	   		}
	   		else {
	   			var arrName = listName;
				if ( arrName == null || arrName == ""){
					arrName =REMINDER_FOX_DEFAULT_TODOS_CATEGORY;
				}
			
				var todosArr =	topWindow.reminderFox_getReminderTodos();													
				var todos = todosArr[arrName];
				if ( todos == null ) {
					todos = new Array();
				}	   			
				
	   			editWindowReminder = topWindow.reminderFox_getTodosById( myAlarmId,  todos );	 
	   		}
	   		if ( editWindowReminder != null ) {
	   			if ( reminder.alarmLastAcknowledge != null ) {
	   				editWindowReminder.alarmLastAcknowledge = reminder.alarmLastAcknowledge;
	   			}
	   			
				if ( actionIndex == 1 )  { // mark as complete
					editWindowReminder.completedDate = new Date();
					if ( isReminder == "true"  ) {
							var modified = topWindow.updateReminderInList( editWindowReminder );							
					}
					else {
							var modified = topWindow.updateTodoInList( editWindowReminder )			
					}
					topWindow.modifiedReminders();
					
				}
				else if ( actionIndex == 2 ) {  // delete   
					if ( isReminder == "true"  ) {
						// remove from UI list
						topWindow.removeListItemsForReminder(editWindowReminder);

						// remove from model list
						var reminders = topWindow.reminderFox_getReminderEvents();	
						for( var i = 0; i < reminders.length; i++) {
							if ( reminders[i].id == editWindowReminder.id ) {
								topWindow.reminderFox_removeElement(reminders, i);							
								break;								
							}
						}		
					}	
					else {
						// remove from UI list
						topWindow.removeTodoListItem(editWindowReminder);  

						// remove from model list
						var reminderFoxTodosArrayArg =  topWindow.reminderFox_getReminderTodos();
						for ( var n in reminderFoxTodosArrayArg ) {
							var reminderTodos = reminderFoxTodosArrayArg[n];
							for (  i = 0; i < reminderTodos.length; i++ ) {		
								if ( reminderTodos[i].id == editWindowReminder.id ) {
									topWindow.reminderFox_removeElement(reminderTodos, i);
									break;							
								}
							}
						}							
					}	
					topWindow.modifiedReminders();	
				}	   				   			
	   		}
	   }					
	   
	   if ( completed || removed ) {
	   		reminderFox_clearRemindersAndTodos();
	   		// update all of the browsers
			windowEnumerator =  reminderFox_getWindowEnumerator();
			while (windowEnumerator.hasMoreElements()) {
				var currentWindow = windowEnumerator.getNext();		
				currentWindow.reminderFoxEvents = reminderFoxEvents;
				currentWindow.reminderFoxTodosArray  = reminderFoxTodosArray; 

				currentWindow.reminderFox_updateRemindersInWindow();			
				currentWindow.reminderFox_clearRemindersAndTodos();				
			}	
	   }
	}
	window.close();
}

function reminderFox_alarmChooseDone() {
	if ( 	document.getElementById("snoozeButton").getAttribute( "default" ) == true ||
		document.getElementById("snoozeButton").getAttribute( "default" ) == "true"	) {
		reminderFox_snooze();
	}
	else {
		reminderFox_alarmDone();
	}
}

function reminderFox_snoozeTimeChanged() {
	document.getElementById("snoozeButton").setAttribute( "default", true );
	document.getElementById("okButton").setAttribute( "default", false );
}

function reminderFox_snooze() {
		reminderFox_snoozed = true;
		var currentAlarmId = window.arguments[0].currentAlarmId;
		var recentReminder = window.arguments[0].alarmreminder;
		var isReminder = window.arguments[0].isReminderType;
		var listName = window.arguments[0].todoListName;
				
		
		
		var snoozeTimeList = document.getElementById("reminderFox-snoozeTime");	
		var snoozeTime = snoozeTimeList.label;
		if ( reminderFox_isInteger( snoozeTime ) ) {
			var timeUnitsList = document.getElementById('reminderFox-alertTimeUnits');			
			if ( timeUnitsList != null ) { 
				var timeSelected = timeUnitsList.selectedIndex;
				if ( timeSelected == 1 ) {
					snoozeTime = snoozeTime * 60;
				}
				else if ( timeSelected == 2 ) {
					snoozeTime = snoozeTime * 60 * 24;
				}	
			}				
			
			var currentTime = new Date().getTime();
			var alarmTime = currentTime + (snoozeTime*60000);		
					
			var windowEnumerator =  reminderFox_getWindowEnumerator();
			if (windowEnumerator.hasMoreElements()) {
				var oldestWindow = windowEnumerator.getNext();
				
				// update existing entry from alarm list with snooze set and updated alarmTime
				for ( var i = 0; i < oldestWindow.reminderFox_alarmList.length; i++ ) {
					var myAlarmId =  oldestWindow.reminderFox_alarmList[i].alarmId;
					if ( currentAlarmId == myAlarmId ) { 
						oldestWindow.reminderFox_alarmList[i].snoozed = true;
						oldestWindow.reminderFox_alarmList[i].timeOfAlarm = alarmTime;
					}
				}
				if ( listName == null ){
					listName = "";
				}				
				oldestWindow.setTimeout('reminderFox_showAlarm("'+recentReminder.date.getTime()+'","'+currentAlarmId +'","'+isReminder +'","'+alarmTime +'","'+listName + '","'+false+ '","'+snoozeTime+'")', snoozeTime*60000);			
							
			}		
		}
	window.close();
}


